//
// Date Last Modified: November 13, 2007
//
// Modified By: Michael Mims (zorphnog), Mark Ritter
//


function OpenRebootFile()
{
	position="reboot.js";
	whatfunc="OpenRebootFile()";

	var rebootFile;

	if (RebootInstallationLog)
	{
		rebootFile=ReplacePath(DefaultRebootFilePath);
		if (ResumeInstall)
		{
			try
			{
				rbfHandle = fso.OpenTextFile(rebootFile,8,false);
			}
			catch (ex)
			{
				alert(getText(NotOpenRebootFile)+"\n"+rebootFile);
				ExitWPI();
			}
		}
		else if (RebootEntryFound)
		{
			try 
			{
				rbfHandle = fso.CreateTextFile(rebootFile,true);
				rbfHandle.WriteLine("// Reboot Configuration File");
				rbfHandle.WriteLine("// Install process started at: "+LogTimeStamp());
				rbfHandle.WriteLine("\r\nprb=0;\r\n");
			}
			catch (ex) 
			{ 
				alert(getText(CouldNotCreateLogFile)+"\r\n"+rebootFile);
				RebootInstallationLog=false;

				return;
			}
		}
	}
}


function RebootEntry(rbProg)
{
	position="reboot.js"; 
	whatfunc="RebootEntry()";

	var txt;

	if (RebootInstallationLog && RebootEntryFound)
	{
		rbfHandle.WriteLine("programs[prb] = new program(prb);");
		rbProg.prog != null ? rbfHandle.WriteLine("programs[prb].prog=["+GetConfigValue(rbProg.prog.toString())+"];") : null;
		rbProg.ordr != null ? rbfHandle.WriteLine("programs[prb].ordr=["+GetConfigValue(rbProg.ordr.toString(),1)+"];") : null;

		txt=GetConfigValue(rbProg.uid.toString());
		txt=txt.replace(/ */g,"");
		rbProg.uid != null ? rbfHandle.WriteLine("programs[prb].uid=["+GetConfigValue(txt,1)+"];") : null;

		rbProg.regb != null ? rbfHandle.WriteLine("programs[prb].regb=["+GetConfigValue(rbProg.regb[0].toString())+"];") : null;
		rbProg.cmd1 != null ? rbfHandle.WriteLine("programs[prb].cmd1=["+GetConfigValue(rbProg.cmd1[0].toString())+"];") : null;
		rbProg.cmd2 != null ? rbfHandle.WriteLine("programs[prb].cmd2=["+GetConfigValue(rbProg.cmd2[0].toString())+"];") : null;
		rbProg.cmd3 != null ? rbfHandle.WriteLine("programs[prb].cmd3=["+GetConfigValue(rbProg.cmd3[0].toString())+"];") : null;
		rbProg.cmd4 != null ? rbfHandle.WriteLine("programs[prb].cmd4=["+GetConfigValue(rbProg.cmd4[0].toString())+"];") : null;
		rbProg.cmd5 != null ? rbfHandle.WriteLine("programs[prb].cmd5=["+GetConfigValue(rbProg.cmd5[0].toString())+"];") : null;
		rbProg.cmd6 != null ? rbfHandle.WriteLine("programs[prb].cmd6=["+GetConfigValue(rbProg.cmd6[0].toString())+"];") : null;
		rbProg.cmd7 != null ? rbfHandle.WriteLine("programs[prb].cmd7=["+GetConfigValue(rbProg.cmd7[0].toString())+"];") : null;
		rbProg.cmd8 != null ? rbfHandle.WriteLine("programs[prb].cmd8=["+GetConfigValue(rbProg.cmd8[0].toString())+"];") : null;
		rbProg.cmd9 != null ? rbfHandle.WriteLine("programs[prb].cmd9=["+GetConfigValue(rbProg.cmd9[0].toString())+"];") : null;
		rbProg.cmd10 != null ? rbfHandle.WriteLine("programs[prb].cmd10=["+GetConfigValue(rbProg.cmd10[0].toString())+"];") : null;
		rbProg.rega != null ? rbfHandle.WriteLine("programs[prb].rega=["+GetConfigValue(rbProg.rega[0].toString())+"];") : null;
		rbfHandle.WriteLine("programs[prb].success=false;");
		rbfHandle.WriteLine("programs[prb].fail=false;");
		rbfHandle.WriteLine("prb++;\r\n");
	}
}

function ScanForEntries(prog)
{
	position="reboot.js";
	whatfunc="ScanForEntries()";

	var numEntries=12, needReboot=false;

	prog.regb != null ? null : numEntries--;
	prog.cmd1 != null ? (prog.cmd1[0].toUpperCase().indexOf("%REBOOT%") == 0 ? needReboot=true : null) : numEntries--;
	prog.cmd2 != null ? (prog.cmd2[0].toUpperCase().indexOf("%REBOOT%") == 0 ? needReboot=true : null) : numEntries--;
	prog.cmd3 != null ? (prog.cmd3[0].toUpperCase().indexOf("%REBOOT%") == 0 ? needReboot=true : null) : numEntries--;
	prog.cmd4 != null ? (prog.cmd4[0].toUpperCase().indexOf("%REBOOT%") == 0 ? needReboot=true : null) : numEntries--;
	prog.cmd5 != null ? (prog.cmd5[0].toUpperCase().indexOf("%REBOOT%") == 0 ? needReboot=true : null) : numEntries--;
	prog.cmd6 != null ? (prog.cmd6[0].toUpperCase().indexOf("%REBOOT%") == 0 ? needReboot=true : null) : numEntries--;
	prog.cmd7 != null ? (prog.cmd7[0].toUpperCase().indexOf("%REBOOT%") == 0 ? needReboot=true : null) : numEntries--;
	prog.cmd8 != null ? (prog.cmd8[0].toUpperCase().indexOf("%REBOOT%") == 0 ? needReboot=true : null) : numEntries--;
	prog.cmd9 != null ? (prog.cmd9[0].toUpperCase().indexOf("%REBOOT%") == 0 ? needReboot=true : null) : numEntries--;
	prog.cmd10 != null ? (prog.cmd10[0].toUpperCase().indexOf("%REBOOT%") == 0 ? needReboot=true : null) : numEntries--;
	prog.rega != null ? null : numEntries--;

	RebootEntryFound ? null : RebootEntryFound=needReboot;
	numCommands += numEntries;
}

function WriteRebootSuccess(i, flag)
{
	position="reboot.js";
	whatfunc="WriteRebootSuccess()";

	if ((RebootInstallationLog && RebootEntryFound) || (RebootInstallationLog && ResumeInstall))
		rbfHandle.WriteLine("programs["+i+"].success="+flag+";");
}


function WriteRebootFail(i, flag)
{
	position="reboot.js";
	whatfunc="WriteRebootSuccess()";

	if ((RebootInstallationLog && RebootEntryFound) || (RebootInstallationLog && ResumeInstall))
		rbfHandle.WriteLine("programs["+i+"].fail="+flag+";");
}


function DeleteRebootFile()
{
	position="reboot.js"
	whatfunc="DeleteRebootFile()";

	var rebootFile;

	rebootFile = ReplacePath(DefaultRebootFilePath);
	if (FileExists(rebootFile) && !RebootInstallationLog)
	{
		cmdLine='cmd /c del /f /q "'+rebootFile+'"';
		try
		{
			WshShell.Run(cmdLine,0,true);
		}
		catch (ex)
		{
			alert(getText(CouldNotDeleteFile)+"\r\n"+rebootFile);
		}
	}
}


function CloseRebootFile()
{
	position="reboot.js";
	whatfunc="CloseRebootFile()";

	if (RebootInstallationLog && rbfHandle != null)
		rbfHandle.Close();
}
